/*----- PROTECTED REGION ID(FitsImporterClass.cpp) ENABLED START -----*/
//static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        FitsImporterClass.cpp
//
// description : C++ source for the FitsImporterClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the FitsImporter once per process.
//
// project :     Fits importer device server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <FitsImporterClass.h>

/*----- PROTECTED REGION END -----*/	//	FitsImporterClass.cpp

//-------------------------------------------------------------------
/**
 *	Create FitsImporterClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_FitsImporter_class(const char *name) {
		return FitsImporter_ns::FitsImporterClass::init(name);
	}
}

namespace FitsImporter_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
FitsImporterClass *FitsImporterClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::FitsImporterClass(string &s)
 * description : 	constructor for the FitsImporterClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
FitsImporterClass::FitsImporterClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering FitsImporterClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(FitsImporterClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::constructor

	cout2 << "Leaving FitsImporterClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::~FitsImporterClass()
 * description : 	destructor for the FitsImporterClass
 */
//--------------------------------------------------------
FitsImporterClass::~FitsImporterClass()
{
	/*----- PROTECTED REGION ID(FitsImporterClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
FitsImporterClass *FitsImporterClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new FitsImporterClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
FitsImporterClass *FitsImporterClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OnClass::execute(): arrived" << endl;
	((static_cast<FitsImporter *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OffClass::execute(): arrived" << endl;
	((static_cast<FitsImporter *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetCounterClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetCounterClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetCounterClass::execute(): arrived" << endl;
	((static_cast<FitsImporter *>(device))->reset_counter());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum FitsImporterClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum FitsImporterClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum FitsImporterClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::get_class_property()
 *	Description : Read database to initialize class property data members.
 */
//--------------------------------------------------------
void FitsImporterClass::get_class_property()
{
	/*----- PROTECTED REGION ID(FitsImporterClass::get_class_property_before) ENABLED START -----*/
	
	//	Initialize class property data members
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("DMDBHost"));
	cl_prop.push_back(Tango::DbDatum("DMDBPort"));
	cl_prop.push_back(Tango::DbDatum("DMDBUser"));
	cl_prop.push_back(Tango::DbDatum("DMDBPassword"));
	cl_prop.push_back(Tango::DbDatum("DMDBSchema"));
	cl_prop.push_back(Tango::DbDatum("DMDBInstrumentTable"));
	cl_prop.push_back(Tango::DbDatum("DMDBDestinationTable"));
	cl_prop.push_back(Tango::DbDatum("DMDBMappingTable"));
	
	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract DMDBHost value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBHost;
	else
	{
		//	Check default value for DMDBHost
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBHost;
			cl_prop[i]  <<  dMDBHost;
		}
	}
	//	Try to extract DMDBPort value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBPort;
	else
	{
		//	Check default value for DMDBPort
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBPort;
			cl_prop[i]  <<  dMDBPort;
		}
	}
	//	Try to extract DMDBUser value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBUser;
	else
	{
		//	Check default value for DMDBUser
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBUser;
			cl_prop[i]  <<  dMDBUser;
		}
	}
	//	Try to extract DMDBPassword value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBPassword;
	else
	{
		//	Check default value for DMDBPassword
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBPassword;
			cl_prop[i]  <<  dMDBPassword;
		}
	}
	//	Try to extract DMDBSchema value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBSchema;
	else
	{
		//	Check default value for DMDBSchema
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBSchema;
			cl_prop[i]  <<  dMDBSchema;
		}
	}
	//	Try to extract DMDBInstrumentTable value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBInstrumentTable;
	else
	{
		//	Check default value for DMDBInstrumentTable
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBInstrumentTable;
			cl_prop[i]  <<  dMDBInstrumentTable;
		}
	}
	//	Try to extract DMDBDestinationTable value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBDestinationTable;
	else
	{
		//	Check default value for DMDBDestinationTable
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBDestinationTable;
			cl_prop[i]  <<  dMDBDestinationTable;
		}
	}
	//	Try to extract DMDBMappingTable value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  dMDBMappingTable;
	else
	{
		//	Check default value for DMDBMappingTable
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  dMDBMappingTable;
			cl_prop[i]  <<  dMDBMappingTable;
		}
	}
	/*----- PROTECTED REGION ID(FitsImporterClass::get_class_property_after) ENABLED START -----*/
	
	//	Check class property data members init
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void FitsImporterClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties
	prop_name = "DMDBHost";
	prop_desc = "Hostname where data model database is running";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBPort";
	prop_desc = "Port where data model database is listening";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBUser";
	prop_desc = "User to login in data model database";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBPassword";
	prop_desc = "Password to login in data model database";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBSchema";
	prop_desc = "Schema where data model tables are located";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBInstrumentTable";
	prop_desc = "Instrument table name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBDestinationTable";
	prop_desc = "Destination table name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "DMDBMappingTable";
	prop_desc = "Mapping table name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "WatchPath";
	prop_desc = "Absolute path where fits importer wait for a new file to ingest";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "WorkerNumber";
	prop_desc = "Number of worker thread to process new file";
	prop_def  = "8";
	vect_data.clear();
	vect_data.push_back("8");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ConnectionNumber";
	prop_desc = "Number of connection created in connection pool for each database entry in destination table";
	prop_def  = "2";
	vect_data.clear();
	vect_data.push_back("2");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EventList";
	prop_desc = "Inotify event that trigger fits importer new file event. \nAllowed event are:\n* IN_ACCESS\n* IN_MODIFY\n* IN_ATTRIB\n* IN_CLOSE_WRITE\n* IN_CLOSE_NOWRITE\n* IN_OPEN\n* IN_MOVED_FROM\n* IN_MOVED_TO\n* IN_DELETE\n* IN_DELETE_SELF\n* IN_CLOSE\n* IN_MOVE\n* IN_ALL_EVENTS";
	prop_def  = "IN_CLOSE_WRITE";
	vect_data.clear();
	vect_data.push_back("IN_CLOSE_WRITE");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SleepTime";
	prop_desc = "Time fits importer event loop has to sleep before check for new file";
	prop_def  = "1000";
	vect_data.clear();
	vect_data.push_back("1000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "WaitTime";
	prop_desc = "Time fits importer has to sleep between new time event and ingestion";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InstrumentList";
	prop_desc = "List of instrument used by fits importer when ingesting file";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DefaultInstrument";
	prop_desc = "Default instrument used by fits importer when:\n1) no instrument match with file\n2) an error occurs during metadata extraction";
	prop_def  = "NONE";
	vect_data.clear();
	vect_data.push_back("NONE");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBHost";
	prop_desc = "Hostname where data model database is running";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBPort";
	prop_desc = "Port where data model database is listening";
	prop_def  = "3306";
	vect_data.clear();
	vect_data.push_back("3306");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBUser";
	prop_desc = "User to login in data model database";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBPassword";
	prop_desc = "Password to login in data model database";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBSchema";
	prop_desc = "Schema where data model tables are located";
	prop_def  = "data_model";
	vect_data.clear();
	vect_data.push_back("data_model");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBInstrumentTable";
	prop_desc = "Instrument table name";
	prop_def  = "instrument";
	vect_data.clear();
	vect_data.push_back("instrument");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBDestinationTable";
	prop_desc = "Destination table name";
	prop_def  = "destination";
	vect_data.clear();
	vect_data.push_back("destination");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DMDBMappingTable";
	prop_desc = "Mapping table name";
	prop_def  = "mapping";
	vect_data.clear();
	vect_data.push_back("mapping");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AutoStart";
	prop_desc = "Exec On command after init if state is not fault";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void FitsImporterClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Fits importer device server");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Fits importer device server");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("FitsImporter");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void FitsImporterClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(FitsImporterClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new FitsImporter(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		FitsImporter *dev = static_cast<FitsImporter *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(FitsImporterClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void FitsImporterClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(FitsImporterClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::attribute_factory_before
	//	Attribute : RegularFileCounter
	RegularFileCounterAttrib	*regularfilecounter = new RegularFileCounterAttrib();
	Tango::UserDefaultAttrProp	regularfilecounter_prop;
	regularfilecounter_prop.set_description("Indicate file correctly ingested");
	//	label	not set for RegularFileCounter
	//	unit	not set for RegularFileCounter
	//	standard_unit	not set for RegularFileCounter
	//	display_unit	not set for RegularFileCounter
	//	format	not set for RegularFileCounter
	//	max_value	not set for RegularFileCounter
	//	min_value	not set for RegularFileCounter
	//	max_alarm	not set for RegularFileCounter
	//	min_alarm	not set for RegularFileCounter
	//	max_warning	not set for RegularFileCounter
	//	min_warning	not set for RegularFileCounter
	//	delta_t	not set for RegularFileCounter
	//	delta_val	not set for RegularFileCounter
	
	regularfilecounter->set_default_properties(regularfilecounter_prop);
	//	Not Polled
	regularfilecounter->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(regularfilecounter);

	//	Attribute : WarningFileCounter
	WarningFileCounterAttrib	*warningfilecounter = new WarningFileCounterAttrib();
	Tango::UserDefaultAttrProp	warningfilecounter_prop;
	warningfilecounter_prop.set_description("Indicate file ingested in default instrument");
	//	label	not set for WarningFileCounter
	//	unit	not set for WarningFileCounter
	//	standard_unit	not set for WarningFileCounter
	//	display_unit	not set for WarningFileCounter
	//	format	not set for WarningFileCounter
	//	max_value	not set for WarningFileCounter
	//	min_value	not set for WarningFileCounter
	//	max_alarm	not set for WarningFileCounter
	//	min_alarm	not set for WarningFileCounter
	//	max_warning	not set for WarningFileCounter
	//	min_warning	not set for WarningFileCounter
	//	delta_t	not set for WarningFileCounter
	//	delta_val	not set for WarningFileCounter
	
	warningfilecounter->set_default_properties(warningfilecounter_prop);
	//	Not Polled
	warningfilecounter->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(warningfilecounter);

	//	Attribute : ErrorFileCounter
	ErrorFileCounterAttrib	*errorfilecounter = new ErrorFileCounterAttrib();
	Tango::UserDefaultAttrProp	errorfilecounter_prop;
	errorfilecounter_prop.set_description("Indicate file not ingested due to an error");
	//	label	not set for ErrorFileCounter
	//	unit	not set for ErrorFileCounter
	//	standard_unit	not set for ErrorFileCounter
	//	display_unit	not set for ErrorFileCounter
	//	format	not set for ErrorFileCounter
	//	max_value	not set for ErrorFileCounter
	//	min_value	not set for ErrorFileCounter
	//	max_alarm	not set for ErrorFileCounter
	//	min_alarm	not set for ErrorFileCounter
	//	max_warning	not set for ErrorFileCounter
	//	min_warning	not set for ErrorFileCounter
	//	delta_t	not set for ErrorFileCounter
	//	delta_val	not set for ErrorFileCounter
	
	errorfilecounter->set_default_properties(errorfilecounter_prop);
	//	Not Polled
	errorfilecounter->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(errorfilecounter);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(FitsImporterClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void FitsImporterClass::command_factory()
{
	/*----- PROTECTED REGION ID(FitsImporterClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::command_factory_before


	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command ResetCounter
	ResetCounterClass	*pResetCounterCmd =
		new ResetCounterClass("ResetCounter",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCounterCmd);

	/*----- PROTECTED REGION ID(FitsImporterClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void FitsImporterClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(FitsImporterClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		FitsImporterClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void FitsImporterClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		FitsImporter *dev = static_cast<FitsImporter *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(FitsImporterClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporterClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *FitsImporterClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(FitsImporterClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::Additional Methods
} //	namespace
