/*----- PROTECTED REGION ID(FitsImporterClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        FitsImporterClass.h
//
// description : Include for the FitsImporter root class.
//               This class is the singleton class for
//                the FitsImporter device class.
//               It contains all properties and methods which the 
//               FitsImporter requires only once e.g. the commands.
//
// project :     Fits importer device server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef FitsImporterClass_H
#define FitsImporterClass_H

#include <tango.h>
#include <FitsImporter.h>


/*----- PROTECTED REGION END -----*/	//	FitsImporterClass.h


namespace FitsImporter_ns
{
/*----- PROTECTED REGION ID(FitsImporterClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute RegularFileCounter class definition
class RegularFileCounterAttrib: public Tango::Attr
{
public:
	RegularFileCounterAttrib():Attr("RegularFileCounter",
			Tango::DEV_ULONG, Tango::READ) {};
	~RegularFileCounterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FitsImporter *>(dev))->read_RegularFileCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FitsImporter *>(dev))->is_RegularFileCounter_allowed(ty);}
};

//	Attribute WarningFileCounter class definition
class WarningFileCounterAttrib: public Tango::Attr
{
public:
	WarningFileCounterAttrib():Attr("WarningFileCounter",
			Tango::DEV_ULONG, Tango::READ) {};
	~WarningFileCounterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FitsImporter *>(dev))->read_WarningFileCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FitsImporter *>(dev))->is_WarningFileCounter_allowed(ty);}
};

//	Attribute ErrorFileCounter class definition
class ErrorFileCounterAttrib: public Tango::Attr
{
public:
	ErrorFileCounterAttrib():Attr("ErrorFileCounter",
			Tango::DEV_ULONG, Tango::READ) {};
	~ErrorFileCounterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FitsImporter *>(dev))->read_ErrorFileCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FitsImporter *>(dev))->is_ErrorFileCounter_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FitsImporter *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FitsImporter *>(dev))->is_Off_allowed(any);}
};

//	Command ResetCounter class definition
class ResetCounterClass : public Tango::Command
{
public:
	ResetCounterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetCounterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetCounterClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FitsImporter *>(dev))->is_ResetCounter_allowed(any);}
};


/**
 *	The FitsImporterClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  FitsImporterClass : public Tango::DeviceClass
#else
class FitsImporterClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(FitsImporterClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporterClass::Additionnal DServer data members

	//	Class properties data members
	public:
		//	DMDBHost:	Hostname where data model database is running
		string	dMDBHost;
		//	DMDBPort:	Port where data model database is listening
		Tango::DevULong	dMDBPort;
		//	DMDBUser:	User to login in data model database
		string	dMDBUser;
		//	DMDBPassword:	Password to login in data model database
		string	dMDBPassword;
		//	DMDBSchema:	Schema where data model tables are located
		string	dMDBSchema;
		//	DMDBInstrumentTable:	Instrument table name
		string	dMDBInstrumentTable;
		//	DMDBDestinationTable:	Destination table name
		string	dMDBDestinationTable;
		//	DMDBMappingTable:	Mapping table name
		string	dMDBMappingTable;
	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static FitsImporterClass *init(const char *);
		static FitsImporterClass *instance();
		~FitsImporterClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		FitsImporterClass(string &);
		static FitsImporterClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	FitsImporter_H
