/*----- PROTECTED REGION ID(FitsImporterStateMachine.cpp) ENABLED START -----*/
//static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        FitsImporterStateMachine.cpp
//
// description : State machine file for the FitsImporter class
//
// project :     Fits importer device server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <FitsImporter.h>

/*----- PROTECTED REGION END -----*/	//	FitsImporter::FitsImporterStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  OFF     |  Fits importer is not active (not ready ingest data)
//  ON      |  Fits importer is in ON state (ready to ingest data)
//  FAULT   |  Fits importer is in FAULT state (not ready to ingest data)
//  ALARM   |  Fits importer is in ALARM state (not ready to ingest data)


namespace FitsImporter_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_RegularFileCounter_allowed()
 *	Description : Execution allowed for RegularFileCounter attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_RegularFileCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(FitsImporter::RegularFileCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::RegularFileCounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_WarningFileCounter_allowed()
 *	Description : Execution allowed for WarningFileCounter attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_WarningFileCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(FitsImporter::WarningFileCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::WarningFileCounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_ErrorFileCounter_allowed()
 *	Description : Execution allowed for ErrorFileCounter attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_ErrorFileCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(FitsImporter::ErrorFileCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::ErrorFileCounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_On_allowed()
 *	Description : Execution allowed for On attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::FAULT ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(FitsImporter::OnStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::OnStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_Off_allowed()
 *	Description : Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(FitsImporter::OffStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::OffStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : FitsImporter::is_ResetCounter_allowed()
 *	Description : Execution allowed for ResetCounter attribute
 */
//--------------------------------------------------------
bool FitsImporter::is_ResetCounter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(FitsImporter::ResetCounterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	FitsImporter::ResetCounterStateAllowed
		return false;
	}
	return true;
}

}	//	End of namespace
