#include <stdio.h>
#include <openssl/md5.h>

std::string computeMd5(boost::filesystem::path& filePath)
{
  unsigned char digest[MD5_DIGEST_LENGTH];

  const char *filename=filePath.string().c_str();
  int i;
  FILE *inFile = fopen (filename, "rb");
  MD5_CTX mdContext;
  int bytes;
  unsigned char data[1024];

  if (inFile == NULL) {
    printf ("%s can't be opened.\n", filename);
    return 0;
  }

  MD5_Init (&mdContext);
  while ((bytes = fread (data, 1, 1024, inFile)) != 0)
    MD5_Update (&mdContext, data, bytes);
  MD5_Final (digest,&mdContext);

  char mdString[33];

  for(i = 0; i < MD5_DIGEST_LENGTH; i++)
    sprintf(&mdString[i*2], "%02x", (unsigned int)digest[i]);

  fclose (inFile);
  return mdString;
}
